=== plugins/enttecwing/CMakeLists.txt ===
project(enttecwing)

add_subdirectory(src)
add_subdirectory(test)
