=== plugins/velleman/CMakeLists.txt ===
project(velleman)

add_subdirectory(src)
add_subdirectory(test)
