=== resources/meshes/CMakeLists.txt ===
project(meshes)

add_subdirectory(fixtures)
add_subdirectory(generic)
add_subdirectory(stage)
