=== debian/changelog ===
qlcplus (4.14.1-1) unstable; urgency=medium

  * New upstream version 4.14.1
  * d/control: Bump Standards-Versions to 4.7.2

 -- Jerome Lebleu <jerome@maroufle.fr>  Sun, 23 Mar 2025 19:06:50 +0100
