=== debian/control ===
Source: qlcplus
Section: misc
Priority: optional
Maintainer: Jerome Lebleu <jerome@maroufle.fr>
Build-Depends: cmake,
               debhelper-compat (= 13),
               libasound2-dev (>= 1.0.16),
               libfftw3-dev,
               libftdi1-dev,
               libmad0-dev,
               libqt5serialport5-dev,
               libqt5svg5-dev,
               libqt5websockets5-dev,
               libsndfile1-dev,
               libudev-dev,
               libusb-1.0-0-dev (>= 2:0.1.12),
               libxml2-utils,
               localehelper <!nocheck>,
               pkgconf,
               python3,
               python3-lxml,
               qtdeclarative5-dev,
               qtmultimedia5-dev,
               qtscript5-dev,
               qttools5-dev,
               shared-mime-info (>= 0.71),
               systemd-dev,
               xauth <!nocheck>,
               xvfb <!nocheck>
Standards-Version: 4.7.2
Homepage: https://www.qlcplus.org/
Vcs-Git: https://salsa.debian.org/jlebleu/qlcplus.git
Vcs-Browser: https://salsa.debian.org/jlebleu/qlcplus
Rules-Requires-Root: no

Package: qlcplus
Architecture: any
Depends: qlcplus-data (= ${source:Version}), ${misc:Depends}, ${shlibs:Depends}
Recommends: libmad0, libqt5multimedia5-plugins, libsndfile1
Description: Control DMX or analog lighting systems
 Q Light Controller Plus is a software lighting desk for controlling
 DMX or analog lighting systems like moving heads, dimmers, scanners.
 .
 This project is a fork of the great QLC project written by Heikki Junnila
 that aims to continue the QLC development and to introduce new features. The
 primary goal is to bring QLC+ at the level of other lighting control commercial
 software.

Package: qlcplus-data
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: Control DMX or analog lighting systems (data files)
 Q Light Controller Plus is a software lighting desk for controlling
 DMX or analog lighting systems like moving heads, dimmers, scanners.
 .
 This project is a fork of the great QLC project written by Heikki Junnila
 that aims to continue the QLC development and to introduce new features. The
 primary goal is to bring QLC+ at the level of other lighting control commercial
 software.
 .
 This package contains architecture-independent data files.
